package com.fr.plugin.decision.auth.config;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;

@Visualization(category = "统一身份认证参数配置")
public class AuthLoginPluginConfig extends DefaultConfiguration {

    private static volatile AuthLoginPluginConfig config = null;

    public static AuthLoginPluginConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(AuthLoginPluginConfig.class);
        }
        return config;
    }

    @Identifier(value = "serviceCode", name = "服务代码", description = "服务代码", status = Status.SHOW)
    private Conf<String> serviceCode = Holders.simple("11002000002");

    @Identifier(value = "serviceScene", name = "服务场景", description = "服务场景", status = Status.SHOW)
    private Conf<String> serviceScene = Holders.simple("01");

    @Identifier(value = "consumerId", name = "消费系统ID", description = "消费系统ID", status = Status.SHOW)
    private Conf<String> consumerId = Holders.simple("406100");

    @Identifier(value = "consumerSeqNo", name = "消费顺序号码", description = "消费顺序号码", status = Status.SHOW)
    private Conf<String> consumerSeqNo = Holders.simple("01G4HNQ8YQDWQSKAHVSB31A6CQ");

    @Identifier(value = "systemNo", name = "系统编码", description = "系统编码", status = Status.SHOW)
    private Conf<String> systemNo = Holders.simple("bizpm");

    @Identifier(value = "url", name = "请求URL", description = "请求URL", status = Status.SHOW)
    private Conf<String> url = Holders.simple("http://10.1.136.170:11016/BIZPM");

    public String getServiceCode() {
        return serviceCode.get();
    }

    public void setServiceCode(String serviceCode) {
        this.serviceCode.set(serviceCode);
    }

    public String getServiceScene() {
        return serviceScene.get();
    }

    public void setServiceScene(String serviceScene) {
        this.serviceScene.set(serviceScene);
    }

    public String getConsumerId() {
        return consumerId.get();
    }

    public void setConsumerId(String consumerId) {
        this.consumerId.set(consumerId);
    }

    public String getConsumerSeqNo() {
        return consumerSeqNo.get();
    }

    public void setConsumerSeqNo(String consumerSeqNo) {
        this.consumerSeqNo.set(consumerSeqNo);
    }

    public String getSystemNo() {
        return systemNo.get();
    }

    public void setSystemNo(String systemNo) {
        this.systemNo.set(systemNo);
    }

    public String getUrl() {
        return url.get();
    }

    public void setUrl(String url) {
        this.url.set(url);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {

        AuthLoginPluginConfig cloned = (AuthLoginPluginConfig) super.clone();

        cloned.serviceCode = (Conf<String>) serviceCode.clone();
        cloned.serviceScene = (Conf<String>) serviceScene.clone();
        cloned.consumerId = (Conf<String>) consumerId.clone();
        cloned.consumerSeqNo = (Conf<String>) consumerSeqNo.clone();
        cloned.systemNo = (Conf<String>) systemNo.clone();
        cloned.url = (Conf<String>) url.clone();

        return cloned;
    }

}
