package com.fr.plugin.decision.auth.config;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;

@Visualization(category = "单点登录参数配置")
public class SsoLoginPluginConfig extends DefaultConfiguration {

    private static volatile SsoLoginPluginConfig config = null;

    public static SsoLoginPluginConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(SsoLoginPluginConfig.class);
        }
        return config;
    }

    @Identifier(value = "serviceCode", name = "服务代码", description = "服务代码", status = Status.SHOW)
    private Conf<String> serviceCode = Holders.simple("11002000152");

    @Identifier(value = "serviceScene", name = "服务场景", description = "服务场景", status = Status.SHOW)
    private Conf<String> serviceScene = Holders.simple("01");

    @Identifier(value = "consumerId", name = "消费系统ID", description = "消费系统ID", status = Status.SHOW)
    private Conf<String> consumerId = Holders.simple("401020");

    @Identifier(value = "targetSysId", name = "目标系统ID", description = "目标系统ID", status = Status.SHOW)
    private Conf<String> targetSysId = Holders.simple("401020");

    @Identifier(value = "systemNo", name = "系统编码", description = "系统编码", status = Status.SHOW)
    private Conf<String> systemNo = Holders.simple("hr");

    @Identifier(value = "url", name = "请求URL", description = "请求URL", status = Status.SHOW)
    private Conf<String> url = Holders.simple("http://10.1.136.170:11016/BIZPM");

    public String getServiceCode() {
        return serviceCode.get();
    }

    public void setServiceCode(String serviceCode) {
        this.serviceCode.set(serviceCode);
    }

    public String getServiceScene() {
        return serviceScene.get();
    }

    public void setServiceScene(String serviceScene) {
        this.serviceScene.set(serviceScene);
    }

    public String getConsumerId() {
        return consumerId.get();
    }

    public void setConsumerId(String consumerId) {
        this.consumerId.set(consumerId);
    }

    public String getTargetSysId() {
        return targetSysId.get();
    }

    public void setTargetSysId(String targetSysId) {
        this.targetSysId.set(targetSysId);
    }

    public String getSystemNo() {
        return systemNo.get();
    }

    public void setSystemNo(String systemNo) {
        this.systemNo.set(systemNo);
    }

    public String getUrl() {
        return url.get();
    }

    public void setUrl(String url) {
        this.url.set(url);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {

        SsoLoginPluginConfig cloned = (SsoLoginPluginConfig) super.clone();

        cloned.serviceCode = (Conf<String>) serviceCode.clone();
        cloned.serviceScene = (Conf<String>) serviceScene.clone();
        cloned.consumerId = (Conf<String>) consumerId.clone();
        cloned.targetSysId = (Conf<String>) targetSysId.clone();
        cloned.systemNo = (Conf<String>) systemNo.clone();
        cloned.url = (Conf<String>) url.clone();

        return cloned;
    }

}
